// optim

#include "optim.h"

#define HALF_MAX_CIRCLE_ANGLE (MAX_CIRCLE_ANGLE/2)
#define QUARTER_MAX_CIRCLE_ANGLE (MAX_CIRCLE_ANGLE/4)
#define MASK_MAX_CIRCLE_ANGLE (MAX_CIRCLE_ANGLE - 1)
#define PI 3.14159265358979323846f

float fast_cossin_table[MAX_CIRCLE_ANGLE];

float fastcos(float x) {
    int i;
	i = (int)(x * HALF_MAX_CIRCLE_ANGLE / PI);
   	if (i < 0) {
		return fast_cossin_table[((-i) + QUARTER_MAX_CIRCLE_ANGLE)&MASK_MAX_CIRCLE_ANGLE];
	} else {
		return fast_cossin_table[(i + QUARTER_MAX_CIRCLE_ANGLE)&MASK_MAX_CIRCLE_ANGLE];
   	}
}

float fastsin(float x) {
	int i;
   	i = (int)(x * HALF_MAX_CIRCLE_ANGLE / PI);
   	if (i < 0) {
      		return fast_cossin_table[(-((-i)&MASK_MAX_CIRCLE_ANGLE)) + MAX_CIRCLE_ANGLE];
   	} else {
      		return fast_cossin_table[i&MASK_MAX_CIRCLE_ANGLE];
   	}
}

void buildsincos(void)
{
	int i;
	for (i = 0; i < MAX_CIRCLE_ANGLE; ++i) {
		fast_cossin_table[i] = (float)sin(i * PI / HALF_MAX_CIRCLE_ANGLE);
}
}

float fastSqrt_2(const float x)
{
  union
  {
    int i;
    float x;
  } u;
  u.x = x;
  u.i = (1<<29) + (u.i >> 1) - (1<<22);
  return u.x;
}
